
local L_TOTAL = "\nTotal"
local L_BLIZZ = "Total & Blizzard AddOns"
local L_TIP = "\n|cffeda55fClick|r to collect garbage"
local L_MB = "MB"
local L_KB = "KB"

local L = GetLocale()
if L == "frFR" then
	L_TOTAL = "\nTotal"
	L_BLIZZ = "Total & AddOns Blizzard"
	L_TIP = "\n|cffeda55fCliquer|r pour récupérer de la mémoire."
	L_MB = "Mo"
	L_KB = "Ko"
end

local _, Mem = ...
local format = string.format
Mem.obj = LibStub("LibDataBroker-1.1"):NewDataObject("Memory", {type = "data source", value = "0", suffix = L_MB, text = "0 "..L_MB})
LibStub("AceTimer-3.0"):Embed(Mem)

local function formatMemory(n)
	if n > 999 then
		return format("%.1f %s", n / 1024, L_MB)
	else
		return format("%.0f %s", n, L_KB)
	end
end

function Mem:Update()
	UpdateAddOnMemoryUsage()
	local total = 0
	for i = 1, GetNumAddOns() do
		total = total + GetAddOnMemoryUsage(i)
	end
	Mem.obj.text = formatMemory(total)
	if total > 999 then
		Mem.obj.suffix = L_MB
		Mem.obj.value = format("%.1f", total / 1024)
	else
		Mem.obj.suffix = L_KB
		Mem.obj.value = format("%.0f", total)
	end
end

Mem:ScheduleRepeatingTimer("Update", 30)
Mem:ScheduleTimer("Update", 5)

function Mem.obj.OnClick()
	GameTooltip:Hide()
	collectgarbage("collect")
	Mem:Update()
end

local function mySort(x,y)
	return x > y
end

local memTbl, sortTbl = {}, {}
function Mem.obj.OnTooltipShow(tooltip)
	if not tooltip or not tooltip.AddLine or not tooltip.AddDoubleLine then return end

	UpdateAddOnMemoryUsage()
	local grandtotal = collectgarbage("count")
	local total = 0

	for i = 1, GetNumAddOns() do
		local memused = GetAddOnMemoryUsage(i)
		if memused > 0 then
			total = total + memused
			memTbl[memused] = GetAddOnInfo(i)
			sortTbl[#sortTbl+1] = memused
		end
	end

	table.sort(sortTbl, mySort)
	local killPoint = tonumber(SB_MEM_KILL) or 0
	for i=1, #sortTbl do
		local val = sortTbl[i]
		tooltip:AddDoubleLine(format("%d. %s", i, memTbl[val]), formatMemory(val), 0, 1, 1, 0, 1, 0)
		if i == killPoint then break end
	end
	wipe(memTbl)
	wipe(sortTbl)

	tooltip:AddDoubleLine(L_TOTAL, formatMemory(total), 1, 1, 1, 0, 1, 0)
	tooltip:AddDoubleLine(L_BLIZZ, formatMemory(grandtotal), 1, 1, 1, 0, 1, 0)
	tooltip:AddLine(L_TIP, 1, 1, 1)
end

